<!--
<?xml version="1.0" ?>
<!DOCTYPE chapter PUBLIC "-//KDE//DTD DocBook XML V4.2-Based Variant V1.1//EN"
 "dtd/kdex.dtd">
-->


<chapter id="contribute">
<title>Contributing</title>

<qandaset>
<qandaentry>
<question>
<para>How can I contribute to &kde;?</para>
</question>
<answer>
<para>&kde; is a free software project that lives from voluntary
contributions.  Everybody is encouraged to contribute to &kde;.  Not
only programmers are welcome.  There are many ways in which you can
help to improve &kde;:</para>
<itemizedlist>
<listitem><para>Test the software.</para></listitem>
<listitem><para>Send in bug reports.  For more information on this,
see <link linkend="bug-report">How do I submit a bug
report?</link>.</para></listitem>
<listitem><para>Write documentation or help files.  You can get some
information by visiting the <ulink
url="http://l10n.kde.org/docs/">&kde; Editorial Team
Home Page</ulink>.</para></listitem>
<listitem><para>Translate programs, documentation, and help files.
For more information on this, you should visit <ulink
url="http://l10n.kde.org">The &kde; Translators' and Documenters' Web
Site</ulink>.</para></listitem>
<listitem><para>Draw nice icons or compose sound effects.  You can
visit the <ulink url="http://kde-artists.org/">&kde;
artists page</ulink> to find out more.</para></listitem>
<listitem><para>Write articles and books about &kde;.  If you want to
help spread the word about &kde;, simply send an email to
<email>kde-promo@kde.org</email>.  This will get you in touch 
with the &kde; public relations volunteers.</para></listitem>
<listitem><para>Program new &kde; applications.  Please refer to <xref
linkend="programming"/> for more information.</para></listitem>
<listitem><para> Of course, sponsors are also
welcome. :-)</para></listitem>
</itemizedlist>
<para>There are several places to look for more information if you
want to get involved in the development.  The first step is to
subscribe to some of the <ulink  url="http://www.kde.org/mailinglists/">mailing 
lists</ulink>.  You will soon see something
that can be improved or added.</para>
</answer>
</qandaentry>

<qandaentry>
<question id="bug-report">
<para>How do I submit a bug report?</para>
</question>
<answer>
<para>There is a bug tracking system available at <ulink
url="http://bugs.kde.org">http://bugs.kde.org</ulink>.  The
system features a wizard to submit new bug reports and a
list of all known bugs.</para>
<para>The easiest way to submit a bug is to select
<menuchoice><guimenu>Help</guimenu><guimenuitem>Report 
Bug...</guimenuitem></menuchoice> from the menu bar of the application
with the bug.  This will open a small dialog box with a link
to the bug tracking system. Please make sure to follow the
instructions of the bug reporting wizard.</para>
</answer>
</qandaentry>

<qandaentry>
<question id="programming">
<para>I want to program for &kde;.  What should I do first?</para>
</question>
<answer>
<para>Everybody is encouraged to develop software for &kde;.  What you
should do first depends strongly on your experience, &eg; whether you have
already learned C++ or have experience with the &Qt; toolkit and so
on.</para>
<para>To get into &kde; programming, you will need some basic tools:
<application>cmake</application>, and
<application>gcc</application>.  You should look to <ulink 
url="http://techbase.kde.org/">http://techbase.kde.org/</ulink>
for more tips.
</para>
<para>Another excellent resource for learning &kde;
programming is the &Qt; 
online tutorials.  These are installed along with &Qt;.  To view them,
open <filename>$<envar>QTDIR</envar>/doc/html/index.html</filename> in 
&konqueror; and bookmark it.  The tutorials
can be found under "Using 
Qt".  The source code for each lesson can be found in the <filename
class="directory">$<envar>QTDIR</envar>/tutorial</filename>
directory.</para>
<para>There is, however, one thing that everybody interested in
programming for &kde; should do: <emphasis>subscribe to the developers
mailing list</emphasis>.  To subscribe, you have to send an email to
<ulink
url="mailto:kde-devel-request@kde.org">kde-devel-request@kde.org</ulink>
with the subject <userinput>subscribe
<replaceable>your_email_address</replaceable></userinput>.
<important><para>Please read <link linkend="subscribe">How to
subscribe/unsubscribe to these lists</link> carefully.  Everything
said there applies to the development list as
well.</para></important></para>
</answer>
</qandaentry>

<qandaentry>
<question>
<para>How do I get access to &kde; <acronym>SVN</acronym>?</para>
</question>
<answer>
<para>The &kde; project uses <acronym>SVN</acronym> to develop the
core parts of the software.  Usually, when you have changed one of the
parts (&eg; fixed a bug), and you want to commit this change, the best
way is to create a patch against a current snapshot and send this
patch to the developer/maintainer of the respective program.</para>
<para>If you are doing this more or less regularly, there are instructions here on how to get write access to the <acronym>SVN</acronym> repository: <ulink url="http://techbase.kde.org/Contribute/Get_a_SVN_Account">
http://techbase.kde.org/Contribute/Get_a_SVN_Account</ulink>.  But be aware that more users will slow
down <acronym>SVN</acronym> access for all developers, so we want to
keep the number of people with direct <acronym>SVN</acronym> access
reasonably small.  But feel free to ask!</para>
</answer>
</qandaentry>

<qandaentry>
<question>
<para>Can I have read-only access to the <acronym>SVN</acronym> repository?</para>
</question>
<answer>
<para>Yes. Instructions on how to get anonymous, read-only <acronym>SVN</acronym> access are here: <ulink url="http://techbase.kde.org/Getting_Started/Sources/Anonymous_SVN">
http://techbase.kde.org/Getting_Started/Sources/Anonymous_SVN</ulink>
</para>
</answer>
</qandaentry>

<qandaentry>
<question>
<para>Are there any <acronym>SVN</acronym> mirror sites for &kde;?</para>
</question>
<answer>
<para>No, there are currently no anonymous <acronym>SVN</acronym> mirror sites for &kde;. If you're interested in setting one up, please contact <email>sysadmin@kde.org</email>
</para>
</answer>
</qandaentry>

<qandaentry>
<question>
<para>How do I go about translating &kde; programs into my native
language?</para>
</question>
<answer>
<para>Look at the <ulink url="http://l10n.kde.org">The &kde;
Translators' and Documenters' Web Site</ulink> to see whether your
program is already translated (most are).  Otherwise you will find 
information there on how to do it yourself.</para>
</answer>
</qandaentry>
</qandaset>
</chapter>


